mod Mlogicd

incl Mtex

incl Mtexg

rem 
  \para \bf  Examples of Derived Tableau Rules.  \end 

rem 
  \para \bf  Tableau closure rules.  \end Syntax: 
  \eq* 
    'close** <goal*>'
  \end
  \para Example(s): 
  \items 
   \item \para \ft Tex_f1_g_x_closegg(R) \end 
  \end

rem 
  \para \bf  Tableau expansion rules.  \end 
  \items 
   \item \para \it  Tableaux cut rules.  \end Syntax: 
         \eq* 
           'cut [*] <formula>'
         \end
         \para Example(s): 
         \items 
          \item \para \ft Tex_f1_g_x_cut(R) \end 
                \eq* 
                  Tex_f3_g_x_nrule2(Tex_f0_g_x_nothing,
                                    Tex_f2_g_x_branch(Tex_f1_g_x_assum(R),
                                                      Tex_f1_g_x_assum Tex_f1_g_not(R)),
                                    Tex_f0_g_x_nothing)
                \end
          \item \para \ft Tex_f1_g_x_cutg(R) \end 
                \eq* 
                  Tex_f3_g_x_nrule2(Tex_f0_g_x_nothing,
                                    Tex_f2_g_x_branch(Tex_f1_g_x_goal(R),
                                                      Tex_f1_g_x_assum(R)),
                                    Tex_f0_g_x_nothing)
                \end
         \end
   \item \para \it  Tableau 'flatten' rules.  \end Syntax: 
         \eq* 
           'flatten [*] (<assumption> | <goal*>)'
         \end
         \para Example(s): 
         \items 
          \item \para 
                \ft Tex_f1_g_x_flatteng Tex_f1_g_not Tex_f2_g_and(R,Q) \end 
                \eq* 
                  Tex_f3_g_x_nrule2(Tex_f1_g_x_goal Tex_f1_g_not Tex_f2_g_and(R,
                                                                              Q),
                                    Tex_f1_g_x_goal Tex_f1_g_not(R),
                                    Tex_f1_g_x_goal Tex2_sub(Tex_f0_g_and,1)),
                  Tex_f3_g_x_nrule2(Tex_f1_g_x_goal Tex_f1_g_not Tex_f2_g_and(R,
                                                                              Q),
                                    Tex_f1_g_x_goal Tex_f1_g_not(Q),
                                    Tex_f1_g_x_goal Tex2_sub(Tex_f0_g_and,2))
                \end
          \item \para \ft Tex_f1_g_x_flatten Tex_f1_g_not Tex_f2_g_or(R,Q) \end 
                \eq* 
                  Tex_f3_g_x_nrule2(Tex_f1_g_x_assum Tex_f1_g_not Tex_f2_g_or(R,
                                                                              Q),
                                    Tex_f1_g_x_assum Tex_f1_g_not(R),
                                    Tex_f1_g_x_assum Tex2_sub(Tex_f0_g_or,1)),
                  Tex_f3_g_x_nrule2(Tex_f1_g_x_assum Tex_f1_g_not Tex_f2_g_or(R,
                                                                              Q),
                                    Tex_f1_g_x_assum Tex_f1_g_not(Q),
                                    Tex_f1_g_x_assum Tex2_sub(Tex_f0_g_or,2))
                \end
          \item \para \ft Tex_f1_g_x_flatten Tex_f1_g_not Tex_f2_g_imp(R,Q) \end 
                \eq* 
                  Tex_f3_g_x_nrule2(Tex_f1_g_x_assum Tex_f1_g_not Tex_f2_g_imp(R,
                                                                               Q),
                                    Tex_f1_g_x_assum(R),
                                    Tex_f1_g_x_assum Tex2_sub(Tex_f0_g_imp,1)),
                  Tex_f3_g_x_nrule2(Tex_f1_g_x_assum Tex_f1_g_not Tex_f2_g_imp(R,
                                                                               Q),
                                    Tex_f1_g_x_assum Tex_f1_g_not(Q),
                                    Tex_f1_g_x_assum Tex2_sub(Tex_f0_g_imp,2))
                \end
         \end
   \item \para \it  Tableau 'split' rules.  \end Syntax: 
         \eq* 
           'split [*] (<assumption> | <goal*>)'
         \end
         \para Example(s): 
         \items 
          \item \para \ft Tex_f1_g_x_split Tex_f1_g_not Tex_f2_g_and(R,Q) \end 
                \eq* 
                  Tex_f3_g_x_nrule2(Tex_f1_g_x_assum Tex_f1_g_not Tex_f2_g_and(R,
                                                                               Q),
                                    Tex_f2_g_x_branch(Tex_f1_g_x_assum Tex_f1_g_not(R),
                                                      Tex_f1_g_x_assum Tex_f1_g_not(Q)),
                                    Tex_f1_g_x_goal(Tex_f0_g_and))
                \end
          \item \para \ft Tex_f1_g_x_splitg Tex_f1_g_not Tex_f2_g_or(R,Q) \end 
                \eq* 
                  Tex_f3_g_x_nrule2(Tex_f1_g_x_goal Tex_f1_g_not Tex_f2_g_or(R,Q),
                                    Tex_f2_g_x_branch(Tex_f1_g_x_goal Tex_f1_g_not(R),
                                                      Tex_f1_g_x_goal Tex_f1_g_not(Q)),
                                    Tex_f1_g_x_goal(Tex_f0_g_or))
                \end
          \item \para \ft Tex_f1_g_x_splitg Tex_f1_g_not Tex_f2_g_imp(R,Q) \end 
                \eq* 
                  Tex_f3_g_x_nrule2(Tex_f1_g_x_goal Tex_f1_g_not Tex_f2_g_imp(R,
                                                                              Q),
                                    Tex_f2_g_x_branch(Tex_f1_g_x_goal(R),
                                                      Tex_f1_g_x_goal Tex_f1_g_not(Q)),
                                    Tex_f1_g_x_goal(Tex_f0_g_imp))
                \end
         \end
   \item \para \it  Tableau inversion rules.  \end Syntax: 
         \eq* 
           'inv [*] (<assumption> | <goal*>)'
         \end
         \para Example(s): 
         \items 
          \item \para \ft Tex_f1_g_x_inv(R) \end 
                \eq* 
                  Tex_f3_g_x_nrule2(Tex_f1_g_x_assum(R),
                                    Tex_f1_g_x_goal Tex_f1_g_not(R),
                                    Tex_f1_g_x_assum(Tex_f0_g_not))
                \end
          \item \para \ft Tex_f1_g_x_invg(R) \end 
                \eq* 
                  Tex_f3_g_x_nrule2(Tex_f1_g_x_goal(R),
                                    Tex_f1_g_x_assum Tex_f1_g_not(R),
                                    Tex_f1_g_x_goal(Tex_f0_g_not))
                \end
         \end
   \item \para \it  Tableaux quantifier 'instantiation' rules.  \end Syntax: 
         \eq* 
           'inst [*] (<assumption> | <goal*>) ; <term(s)>'
         \end
         \para Example(s): 
         \items 
          \item \para 
                \ft Tex_f1_g_x_inst Tex_f2_g_x_sc(Tex_f2_g_x_sc(Tex_f2_g_forall(x,
                                                                                Tex_f2_g_forall(y,
                                                                                                Tex3_bappl2(R,
                                                                                                            x,
                                                                                                            y))),
                                                                Tex0_tau),Tex0_rho) \end 
                \eq* 
                  Tex_f3_g_x_nrule2(Tex_f1_g_x_assum Tex_f2_g_forall(x,
                                                                     Tex_f2_g_forall(y,
                                                                                     Tex3_bappl2(R,
                                                                                                 x,
                                                                                                 y))),
                                    Tex_f1_g_x_assum Tex3_bappl2(R,Tex0_tau,
                                                                 Tex0_rho),
                                    Tex_f1_g_x_assum(Tex_f0_g_forall))
                \end
          \item \para \ft Tex_f1_g_x_inst Tex_f2_g_x_sc(Tex_f1_g_not Tex_f2_g_exists(x,
                                                                                     Tex2_bappl1(R,
                                                                                                 x)),
                                                        Tex0_tau) \end 
                \eq* 
                  Tex_f3_g_x_nrule2(Tex_f1_g_x_assum Tex_f1_g_not Tex_f2_g_exists(x,
                                                                                  Tex2_bappl1(R,
                                                                                              x)),
                                    Tex_f1_g_x_assum Tex_f1_g_not Tex2_bappl1(R,
                                                                              Tex0_tau),
                                    Tex_f1_g_x_assum(Tex_f0_g_forall))
                \end
         \end
   \item \para \it  Tableaux quantifier 'eigen-variable' rules.  \end Syntax: 
         \eq* 
           'eigen [*] (<assumption> | <goal*>) ; <eigen-variable(s)>'
         \end
         \para Example(s): 
         \items 
          \item \para 
                \ft Tex_f1_g_x_eigeng Tex_f2_g_x_c(Tex_f2_g_x_sc(Tex_f2_g_forall(x,
                                                                                 Tex_f2_g_forall(y,
                                                                                                 Tex3_bappl2(R,
                                                                                                             x,
                                                                                                             y))),
                                                                 a),b) \end 
                \eq* 
                  Tex_f3_g_x_nrule2(Tex_f1_g_x_goal Tex_f2_g_forall(x,
                                                                    Tex_f2_g_forall(y,
                                                                                    Tex3_bappl2(R,
                                                                                                x,
                                                                                                y))),
                                    Tex_f1_g_x_goal Tex3_bappl2(R,a,b),
                                    Tex_f1_g_x_goal(Tex_f0_g_forall))
                \end
                \para where \ft a \end and \ft b \end are new variables \it  
                (eigen-variables)  \end. 
          \item \para \ft Tex_f1_g_x_eigeng Tex_f2_g_x_sc(Tex_f1_g_not Tex_f2_g_exists(x,
                                                                                       Tex2_bappl1(R,
                                                                                                   x)),
                                                          y) \end 
                \eq* 
                  Tex_f3_g_x_nrule2(Tex_f1_g_x_goal Tex_f1_g_not Tex_f2_g_exists(x,
                                                                                 Tex2_bappl1(R,
                                                                                             x)),
                                    Tex_f1_g_x_goal Tex_f1_g_not Tex2_bappl1(R,a),
                                    Tex_f1_g_x_goal(Tex_f0_g_exists))
                \end
                \para where \ft a \end is a new variable \it  (eigen-variable) 
                 \end 
         \end
  \end

rem 
  \para \bf  Simplification.  \end 
  \items 
   \item \para Negation. 
         \eq* 
           ~\t <-> \f
         \end
         \eq* 
           ~\f <-> \t
         \end
         \eq* 
           ~~R <-> R
         \end
         \eq* 
           ~(R <-> Q) <-> R <-> ~Q
         \end
   \item \para Conjunction. 
         \eq* 
           R & Q <-> Q & R
         \end
         \eq* 
           (P & Q) & R <-> P & Q & R
         \end
         \eq* 
           R & \t <-> R
         \end
         \eq* 
           R & \f <-> \f
         \end
         \eq* 
           R & R <-> R
         \end
         \eq* 
           R & ~R <-> \f
         \end
   \item \para Disjunction. 
         \eq* 
           R \/ Q <-> Q \/ R
         \end
         \eq* 
           (P \/ Q) \/ R <-> P \/ Q \/ R
         \end
         \eq* 
           R \/ \t <-> \t
         \end
         \eq* 
           R \/ \f <-> R
         \end
         \eq* 
           R \/ R <-> R
         \end
         \eq* 
           R \/ ~R <-> \t
         \end
   \item \para Implication. 
         \eq* 
           (R -> \t) <-> \t
         \end
         \eq* 
           (\t -> R) <-> R
         \end
         \eq* 
           (R -> \f) <-> ~R
         \end
         \eq* 
           (\f -> R) <-> \t
         \end
         \eq* 
           (R -> R) <-> \t
         \end
         \eq* 
           (~R -> R) <-> R
         \end
         \eq* 
           (R -> ~R) <-> ~R
         \end
   \item \para Equivalence. 
         \eq* 
           (R <-> Q) <-> Q <-> R
         \end
         \eq* 
           (R <-> \t) <-> R
         \end
         \eq* 
           (R <-> \f) <-> ~R
         \end
         \eq* 
           (R <-> R) <-> \t
         \end
         \eq* 
           (R <-> ~R) <-> \f
         \end
         \eq* 
           (~R <-> Q) <-> R <-> ~Q
         \end
   \item \para Universal quantifier. 
         \eq* 
           \a xR <-> R
         \end
         \eq* 
           \a x\a yR(x,y) <-> \a y\a xR(x,y)
         \end
         \eq* 
           \a x(R(x) & Q(x)) <-> \a xR(x) & \a xQ(x)
         \end
         \eq* 
           \a x(R \/ Q(x)) <-> R \/ \a xQ(x)
         \end
         \eq* 
           \a x(R -> Q(x)) <-> R -> \a xQ(x)
         \end
         \eq* 
           \a x(R(x) -> Q) <-> \e xR(x) -> Q
         \end
   \item \para Existential quantifier. 
         \eq* 
           \e xR <-> R
         \end
         \eq* 
           \e x\e yR(x,y) <-> \e y\e xR(x,y)
         \end
         \eq* 
           \e x(R & Q(x)) <-> R & \e xQ(x)
         \end
         \eq* 
           \e x(R(x) \/ Q(x)) <-> \e xR(x) \/ \e xQ(x)
         \end
         \eq* 
           \e x(R(x) -> Q(x)) <-> \a xR(x) -> \e xQ(x)
         \end
  \end

